/* $Id$ */
#ifndef EQUIV_CLASS_BULK_INCLUDED
#define EQUIV_CLASS_BULK_INCLUDED
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include "bool.h"
#include "bitvector.h"
#include "doublelist.h"


/* Unspliced takes precedence of spliced, which takes precedence over ambiguous */
typedef enum {UNSEEN, BOTH, SPLICED, UNSPLICED} Velocity_T;

#define T Equiv_class_T
typedef struct T *T;

extern void
Equiv_class_free (T *old);
extern T
Equiv_class_new (unsigned int *transcript_indices, unsigned int *transcript_velocities,
		 Bitvector_T *retained_introns, int ntranscripts);
extern void
Equiv_class_print_transcripts (FILE *fp, T this, char *header,
			       unsigned int *transcripti_to_genei,char **all_genes);
extern unsigned int
Equiv_class_first_index (T this);
extern int
Equiv_class_count (T this);
extern void
Equiv_class_add_count (T this);
extern void
Equiv_class_print (T this);
extern int
Equiv_class_cmp (const void *a, const void *b);
extern void
Equiv_class_calc_weights (T this, double *spliced_lengths, Doublelist_T *unspliced_lengths,
			  List_T *all_transcript_introns);
extern void
Equiv_class_EM_update (double *next_alpha_spliced, Doublelist_T *next_alpha_unspliced, T this,
		       double *alpha_spliced, Doublelist_T *alpha_unspliced, List_T *all_transcript_introns);

#undef T
#endif

