/* $Id$ */
#ifndef EQUIV_CLASS_SC_INCLUDED
#define EQUIV_CLASS_SC_INCLUDED
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include "bool.h"
#include "bitvector.h"
#include "doublelist.h"

/* Unspliced takes precedence of spliced, which takes precedence over ambiguous */
typedef enum {UNSEEN, BOTH, SPLICED, UNSPLICED} Velocity_T;

#define T Equiv_class_T
typedef struct T *T;

extern void
Equiv_class_free (T *old);
extern void
Equiv_class_print_barcode (FILE *fp, T this);
extern T
Equiv_class_new (unsigned int *transcript_indices, unsigned int *transcript_velocities,
		 Bitvector_T *retained_introns, Bitvector_T *spliced_introns, int ntranscripts,
		 char *umi_barcode, int umi_id);
extern bool
Equiv_class_revise (T this, unsigned int *transcript_indices, unsigned int *transcript_velocities,
		    Bitvector_T *retained_introns, Bitvector_T *spliced_introns, int ntranscripts);
extern bool
Equiv_class_merge (T dest, T source);
extern int
Equiv_class_UMI_ndiffs (T x, T y);
extern void
Equiv_class_set_genes (T this, unsigned int *transcripti_to_genei);
extern bool
Equiv_class_gene_intersection_p (T equiv_class_i, T equiv_class_j);
extern void
Equiv_class_add_introns (List_T *cell_transcript_introns, T this);
extern void
Equiv_class_print_transcripts (FILE *fp, T this, char *header,
			       unsigned int *transcripti_to_genei,char **all_genes);
extern int
Equiv_class_umi_id (T this);
extern void
Equiv_class_set_umi_id (T this, int umi_id);
extern int
Equiv_class_nreads (T this);
extern void
Equiv_class_combine_nreads (T dest, T source);
extern void
Equiv_class_print (T this);
extern int
Equiv_class_nreads_cmp (const void *a, const void *b);
extern void
Equiv_class_calc_weights (T this, double *spliced_lengths, Doublelist_T *unspliced_lengths,
			  List_T *cell_transcript_introns);
extern void
Equiv_class_EM_update (double *next_alpha_spliced, Doublelist_T *next_alpha_unspliced, T this,
		       double *alpha_spliced, Doublelist_T *alpha_unspliced, List_T *cell_transcript_introns);

#undef T
#endif

